'*******************************************************************************
'*
'* Filename       : psp11test.bas
'* Programmer     : Mamyshev Rafik (RU)
'* Created        : 2012/6/27
'* Last Update    : 2012/8/22
'* Current Version: 1.2
'* Description    : Real time control for psp.
'* CPU            :  AVR, ATmega64/128
'* History        :
'* v. 0.1         : Create new file.
'* v. 1.0         : Create file for AVR Atmega128.
'* v. 1.1         : Designed for pult device.
'*
'*
'*******************************************************************************

     '"    011D" "
     '
     ' pd2-7 
     ' pe0-7 
     ' pb0-7 
     ' pg3-4 
     ' pc0-7 
     ' pa4-7 
     ' pf6   
     ' pf7   
     ' pf0   
     '
     '


$regfile = "m128def.dat"
'$regfile = "m64def.dat"
'$baud1 = 9600
$crystal = 16000000
$hwstack = 32
$swstack = 32
$framesize = 64

Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portf.5 , Db5 = Portf.4 , Db6 = Portf.3 , Db7 = Portf.2 , E = Portf.6 , Rs = Portf.7
Config Adc = Single , Prescaler = Auto , Reference = Avcc

Config Timer1 = Counter , Edge = Falling
Config Timer2 = Counter , Edge = Falling
Config Timer3 = Timer , Prescale = 64                       '  3
On Timer3 Prer_tim3                                         '  3
Disable Ovf1                                                '  Timer1
Disable Interrupts
On Ovf1 Tim1_int
Config Sda = Portd.1                                        '
Config Scl = Portd.0

'Config Watchdog = 2048                                      'reset after 2048 mSec
'Stop Watchdog



                                     '


'************************* ****************************
Config Porte = Input
Config Portb = Input
Config Portc = Output
Config Pinf.0 = Input
Set Pinf.0
Config Pinf.1 = Input
Set Pinf.1
Porte = &B11111111
Portb = &B11111111
Ddrg = &B00000111
Portg = &B00011000
Kn_start Alias Pine.0                                       '
Kn_stop Alias Pine.1
Kn_djup Alias Pine.2                                        '
Kn_djdown Alias Pine.3                                      '
Kn_djlock Alias Pine.4                                      '
Kn_djunlock Alias Pine.5                                    '
Kn_emergency Alias Pine.6                                   '

Lampstart Alias Portg.2                                     '
Lampstop Alias Portc.7                                      '

Rel_dj_doun Alias Portc.6                                   '
Rel_dj_unlock Alias Portc.5                                 '
Rel_vtul_unlock Alias Portc.4                               '
Rel_arm_1 Alias Portc.3                                     '
Rel_arm_2 Alias Portc.2                                     '
Rel_cut Alias Portc.1                                       '
Rel_air_d Alias Portc.0                                     '
Rel_air_r Alias Portg.1                                     '
Rel_rel Alias Portg.0
                                    '
Rel_fvd Alias Porta.6
 Config Rel_fvd = Output                                    '
Rel_djog Alias Porta.7
 Config Rel_djog = Output                                   '
Sens_run Alias Ping.3                                       '

Sens_dj_down Alias Pine.7                                   '
Sens_dj_unlock Alias Pinb.0                                 '
Sens_arm_1o Alias Pinb.1                                    '
Sens_arm_1c Alias Pinb.2                                    '
Sens_arm_2o Alias Pinb.3                                    '
Sens_arm_2c Alias Pinb.4                                    '
Sens_cutup Alias Pinb.5                                     '
Sens_cutdn Alias Pinb.6                                     '
Sens_novtul Alias Pinb.7
                                           '
Sens_count Alias Pind.6
 Config Sens_count = Input : Set Sens_count                 '

Rel_djadj1 Alias Porta.5
 Config Rel_djadj1 = Output                                 '
Rel_djadj2 Alias Porta.4
 Config Rel_djadj2 = Output                                 '
Sens1 Alias Ping.4                                          '
Sens2 Alias Pind.3
 Config Sens2 = Input : Set Sens2                           '

Ledok Alias Portd.5
 Config Ledok = Output                                      '
Led1 Alias Porta.3
 Config Led1 = Output
'**************************  ****************************
Declare Sub Sbros()                                         '  
    Dim Armdown3 As Byte                                    '       1 20
    Dim Cutup2 As Byte                                      '     20
Declare Sub Strt()
    Dim Ksn As Byte                                         ''      
    Dim Atst As Byte                                        ' 
    Dim Avtr As Byte                                        '  
    Dim Armdown As Byte                                     '     20
    Dim Laps As Byte                                        '    
    Dim Vtul_tim As Word                                    '    
Declare Sub R_lcd(msg As String)                            '    
    Dim Rus As String * 1 , Cntr As Byte , I_lcd As Byte
    Dim Msg As String * 16
Declare Sub Tpcount()                                       ' 
    Dim Cntlin1 As Word
    Dim Cntlin2 As Word
    Dim Counlin As Word                                     '  
Declare Sub Stpp()                                          '  


Declare Sub Knobd()                                         '  
 Dim U1 As Word
 Dim Knopka1 As String * 1

Declare Sub Knobf()                                         '  
 Dim U2 As Word
 Dim Knopka2 As String * 1




Declare Sub Knkey()






Declare Sub Mrun()                                          '   

Dim Djamb As Word

Declare Sub Djupdoun()                                      '    



 '------------------------------------------------------------------------------

'************************** ****************************
Reset Rel_dj_doun : Reset Rel_dj_unlock : Set Rel_vtul_unlock       '  
Reset Rel_arm_1 : Reset Rel_arm_2 : Reset Rel_cut           '  
Reset Rel_air_d : Reset Rel_air_r : Reset Lampstart         '  
Set Lampstop : Reset Rel_fvd : Reset Rel_djog               '  
Reset Rel_djadj1 : Reset Rel_djadj2 : Reset Rel_rel         '  
Set Ledok
Start Adc                                                   ' 
Stop Counter1
Counter1 = 0
Stop Counter2
Counter2 = 0
Enable Interrupts
Timer3 = &HEC78                                             '---  20mc
Enable Timer3
Start Timer3

 Cursor Off
 Locate 1 , 1
 Msg = "    2012   "
 Call R_lcd(msg)
 Locate 2 , 1
 Msg = "    1.2   "
 Call R_lcd(msg)
Avtr = 0




Armdown3 = 100 : Cutup2 = 100                               '    
Cntlin1 = 90
Cntlin2 = 120

Do
Call Knkey()
If Atst = 1 Then
 Call Strt()
 End If


Loop
End                                                         'end program




Dim Pertim1 As Word                                         '  
Dim Pertim2 As Word                                         ' 
Dim Pertim3 As Word                                         ' 
Pertim1 = 0
Pertim2 = 0
Pertim3 = 0



Prer_tim3:                                                  '  
'Timer1 = &HEC78
Timer3 = &HEC78                                             '    20 
Incr Pertim1                                                ' 
Incr Pertim2                                                '
Incr Pertim3                                                '
Counlin = Counter1                                          '  
If Counlin > Cntlin1 Then                                   '    
Reset Rel_fvd                                               '
Set Rel_djog                                                '
End If                                                      '
If Counlin >= Cntlin2 Then                                  '    
Reset Rel_djog
Counter1 = 0                                                ' 
Avtr = 1                                                    '  
End If
If Kn_stop = 0 Then                                         '     
Laps = 1 : End If                                           '    




If Pertim3 > 25 Then                                        '   
  Reset Ledok
   If Pertim3 > 50 Then
    Set Ledok
   Pertim3 = 0
End If : End If







Return
'**************************    ****************************

Dim Knopka As String * 2
'Dim Knf As String * 2
'Dim Knf2 As String * 2

Dim Dlf As Byte                                             ' 
Dim Dj_down As Byte                                         '      20
Dj_down = 200


Sub Knkey                                                   '    
 If Kn_start = 0 Then                                       '   
 Knopka = "st"                                              '    
    If Ksn = 1 Then                                         '     
    Goto Knkey5                                             '
    End If
    Call Strt()
    Goto Knkey5 : End If

 If Kn_stop = 0 Then
 Knopka = "sp"                                              '   
    Call Stpp()
    Pertim1 = 0
    If Sens_run = 0 Then                                    '  
    Goto Knkey5 : End If                                    '   
    Knver:
    If Kn_stop = 0 Then                                     '      
    If Pertim1 < 100 Then                                   '    yf;fnbz
    Goto Knver : End If
    Call Sbros()                                            '  
    Counter1 = 0
    Counlin = 0
    Call Tpcount()
    End If
    Goto Knkey5 : End If
                                                    '
If Kn_djup = 0 Then                                         '
    Knopka = "du"                                           '
    Dlf = 1
    Call Djupdoun()
    Goto Knkey5 : End If                                    '
If Kn_djdown = 0 Then                                       '
    Knopka = "dd"                                           '
     Dlf = 2
    Call Djupdoun()
    Goto Knkey5 : End If                                    '
If Kn_djlock = 0 Then                                       '
    Knopka = "lo"                                           '
     Dlf = 3
    Call Djupdoun()
    Goto Knkey5 : End If                                    '
If Kn_djunlock = 0 Then                                     '
    Knopka = "ul"                                           '
      Dlf = 4
    Call Djupdoun()
    Goto Knkey5 : End If                                    '
    If Sens_run = 0 Then                                    '  
    Goto Knkey5 : End If                                    '   
If Kn_emergency = 0 Then
   Knopka = "em"
   Goto Knkey5 : End If                                     '


Knkey5:
Knopka = "no"

Endkn:
Perehod12:
End Sub

'**************            ********************

Declare Sub Wtend()                                         ' (br1 As String * 16 , Br2 As String * 16 , Br3 As Byte)
Dim Br1 As String * 16
Dim Br2 As String * 16
Dim Br3 As Byte
Dim Br4 As Byte
Dim Br5 As Byte


Sub Djupdoun                                                '    
If Sens_run = 0 Then                                        '  
Goto Djupdn : End If                                        '   
Pertim1 = 0                                                 '  
Laps = 0                                                    '    
  Select Case Dlf
     Case 1
         Reset Rel_dj_doun                                  ' 
         Br1 = "           "
         Br2 = "      "
         Br3 = Sens_dj_down
         Br4 = 1
         Br5 = 100
         Wait 3
         Call Wtend
    Case 2
         Set Rel_dj_doun                                    ' 
         Br1 = "           "                           '
         Br2 = "     "
         Br3 = Sens_dj_down
         Br4 = 0
         Br5 = 100
         Wait 1
         Call Wtend
    Case 3
         Reset Rel_dj_unlock                                ' 
         Br1 = "           "
         Br2 = "         "
         Br3 = Sens_dj_unlock
         Br4 = 1
         Br5 = 100
         Wait 3
         Call Wtend
    Case 4
         Set Rel_dj_unlock                                  ' 
         Br1 = "           "                           '
         Br2 = "      "
         Br3 = Sens_dj_unlock
         Br4 = 0
         Br5 = 100
         Wait 1
         Call Wtend
End Select
Djupdn:
Knopka = "no"
End Sub
'-------------------------------------------------------------------------------
Sub Wtend
 Laps = 0
 Do                                                         '    
         If Br3 = Br4 Then                                  '  
         Laps = 1 : End If                                  '    
         If Pertim1 > Br5 Then                              '    
         Locate 1 , 1                                       '     
         Msg = Br1                                          '
         Call R_lcd(msg)                                    '
         Locate 2 , 1
         Msg = Br2
         Call R_lcd(msg)
         End If
         Loop Until Laps = 1
'         Atst = 0                                           '  
'         Ksn = 0                                            '     

End Sub

'**************************         ****************************
'  --1__1--!--2__2---      
'
' Sens_arm_1o  Sens_arm_1c Sens_arm_2c   Sens_arm_2o         
'
'      Rel_arm_1                   Rel_arm_2                
'
'


Vtul_tim = 500
Armdown = 50

Sub Strt                                                    '   
Ksn = 1                                                     '    
Avtr = 0                                                    '   
'   Locate 1 , 1
'   Msg = "           "
'   Call R_lcd(msg)
'   Locate 2 , 1
'   Msg = "          "
'   Call R_lcd(msg)

If Sens_dj_down = 0 Or Sens_dj_unlock = 0 Then              '  
  Locate 1 , 1
  Msg = "           "
  Call R_lcd(msg)
  Locate 2 , 1
  Msg = "        "
  Call R_lcd(msg)
  Atst = 0
  Ksn = 0                                                   '     
  Goto Endstrt : End If


If Sens_arm_1c = 0 Then                                     '  ,  
  If Sens_arm_2c = 0 Then
  Rel_vtul_unlock = 0                                       '  
End If : End If
  Waitms Vtul_tim                                           '  
If Sens_cutup = 0 Or Sens_cutdn = 1 Then                    '  
    Locate 1 , 1                                            '    
   Msg = "           "                                 '
   Call R_lcd(msg)                                          '
   Locate 2 , 1
   Msg = "          "
   Call R_lcd(msg)
   Atst = 0
   Ksn = 0                                                  '     
 Goto Endstrt : End If
Lampstop = 0
Lampstart = 1                                               '   
Rel_arm_1 = 1 : Rel_arm_2 = 1                               '   
Pertim1 = 0
Do
If Kn_stop = 0 Then                                         '     
Goto Endstrt : End If
If Sens_arm_1o = 0 Then                                     '  
If Sens_arm_2o = 0 Then
 Laps = 1                                                   '  
End If : End If
If Pertim1 > Armdown Then                                   '    
    Locate 1 , 1                                            '    
   Msg = "          "                                 '
   Call R_lcd(msg)                                          '
   Locate 2 , 1
   Msg = "         "
   Call R_lcd(msg)
   Atst = 0
   Ksn = 0                                                  '     
   Goto Endstrt : End If
Loop Until Laps = 1                                         '     
Call Mrun()                                                 '    
Endstrt:
Knopka = "no"
End Sub
'**************************        ****************************
Sub Stpp
 Reset Rel_fvd                                              ' 
 Reset Rel_djog
  Atst = 0                                                  '  
  Ksn = 0                                                   '     
  Lampstop = 1
  Lampstart = 0
End Sub

'**********************          *************************




Dim Vt_unlock As Byte                                       '   
Dim Tapelin As Word                                         ' 
Dim Mdrv As Byte                                            '   
Dim Mdrvtim As Byte                                         '    20
Dim Airrir As Byte                                          '  
Airrir = 200
Mdrvtim = 30                                                '   
Vt_unlock = 250



Sub Mrun                                                    '   
Laps = 0
Start Counter1
Rel_fvd = 1                                                 '   
Pertim1 = 0                                                 '  
Do
        If Kn_stop = 0 Then                                 '     
        Atst = 0
        Goto Endst2 : End If
        If Sens_run = 0 Then                                '  
        Laps = 1                                            '   
        End If
        If Pertim1 > Mdrvtim Then                           '    
        Locate 1 , 1                                        '    
        Msg = "       "                            '
        Call R_lcd(msg)                                     '
        Locate 2 , 1
        Msg = "    "
        Call R_lcd(msg)
        Atst = 0
        Goto Endst2 : End If
Loop Until Laps = 1
Pertim1 = 0
Set Rel_air_d                                               '  
Waitms Airrir                                               '  
Set Rel_air_r                                               '  
Waitms 300                                                  '  
Reset Rel_air_d                                             '   
Reset Rel_air_r
Call Tpcount
If Avtr = 1 Then                                            '  
Call Sbros                                                  '    
End If
Atst = 1                                                    '  
Endst2:
End Sub

'***********************    **************************
Sub Sbros()
If Sens_run = 0 Then                                        '  
Goto Endsbr : End If                                        '   
Laps = 0                                                    '    
Reset Rel_arm_1                                             '    
Pertim1 = 0                                                 ' 
   Br1 = "    "
   Br2 = "          "
   Br3 = Sens_arm_1c                                        '  
   Br4 = 0
   Br5 = Armdown3
   Call Wtend                                               '    
   If Laps = 1 Then                                         '   
   Goto Pos1 : End If
   Atst = 0                                                 ' 
   Goto Endstrt
Pos1:                                                       '    
Set Rel_cut
Laps = 0                                                    '   
Pertim1 = 0                                                 ' 
   Br1 = "             "
   Br2 = "      "
   Br3 = Sens_cutup                                         '  
   Br4 = 0
   Br5 = Cutup2
   Call Wtend                                               '    
   If Laps = 1 Then                                         '   
   Goto Pos2 : End If
   Atst = 0                                                 ' 
   Goto Endstrt
Pos2:                                                       '    
   Waitms 100                                               '  
Reset Rel_cut                                               ' 
   Laps = 0                                                 ' 
Pertim1 = 0                                                 ' 
   Br1 = "             "
   Br2 = "     "
   Br3 = Sens_cutdn                                         '  
   Br4 = 0
   Br5 = Cutup2
   Call Wtend                                               '    
   If Laps = 1 Then                                         '   
   Goto Pos3 : End If
   Atst = 0                                                 ' 
   Goto Endstrt
Pos3:
Set Rel_vtul_unlock                                         '  
Waitms Vt_unlock                                            '   
Reset Rel_arm_2                                             '    
Laps = 0                                                    ' 
Pertim1 = 0                                                 ' 
   Br1 = "    "
   Br2 = "        "
   Br3 = Sens_arm_2c                                        '    
   Br4 = 0
   Br5 = Armdown3
   Call Wtend                                               '    
   If Laps = 1 Then                                         '   
   Goto Pos4 : End If
   Atst = 0                                                 ' 
   Goto Endstrt
Pos4:
Laps = 0
Pertim1 = 0
Endsbr:
End Sub
 '**********************           *************************


Avtr = 0                                                    '  


 Sub Tpcount

 Do
  If Kn_stop = 0 Then                                       '     
Atst = 0
Goto Endcnt : End If


  Locate 1 , 1
    Msg = "    "
   Call R_lcd(msg)
   Locate 2 , 1
   Lcd Counlin ; "          "



 Loop Until Avtr = 1

Endcnt:


End Sub






'*************************  ***************************
Sub Knobd                                                   '
'Start Watchdog                                              '  
U1 = Getadc(0)                                              '
    If U1 > 990 Then : Knopka1 = "W" : Goto Knop1 : End If  '    
    If U1 =< 45 Then : Knopka1 = "0" : Goto Knop1 : End If  '
    If U1 > 60 Then : If U1 =< 140 Then : Knopka1 = "9" : Goto Knop1 : End If : End If       '
    If U1 > 160 Then : If U1 =< 240 Then : Knopka1 = "8" : Goto Knop1 : End If : End If       '
    If U1 > 260 Then : If U1 =< 340 Then : Knopka1 = "7" : Goto Knop1 : End If : End If
    If U1 > 360 Then : If U1 =< 440 Then : Knopka1 = "6" : Goto Knop1 : End If : End If
    If U1 > 460 Then : If U1 =< 540 Then : Knopka1 = "5" : Goto Knop1 : End If : End If
    If U1 > 560 Then : If U1 =< 640 Then : Knopka1 = "4" : Goto Knop1 : End If : End If       '
    If U1 > 660 Then : If U1 =< 740 Then : Knopka1 = "3" : Goto Knop1 : End If : End If
    If U1 > 760 Then : If U1 =< 840 Then : Knopka1 = "2" : Goto Knop1 : End If : End If
    If U1 > 860 Then : If U1 =< 940 Then : Knopka1 = "1" : End If : End If
Knop1:
'Stop Watchdog
 End Sub


'**************************  ****************************
Sub Knobf                                                   '
'Start Watchdog                                              '  
U2 = Getadc(1)                                              '
    If U2 > 980 Then : Knopka2 = "X" : Goto Knop2 : End If  '    
    If U2 < 32 Then : Knopka2 = "A" : Goto Knop2 : End If   '   F1
    If U2 > 120 Then : If U2 =< 300 Then : Knopka2 = "B" : Goto Knop2 : End If : End If       '  F2
    If U2 > 320 Then : If U2 =< 500 Then : Knopka2 = "C" : Goto Knop2 : End If : End If       '  F3
    If U2 > 520 Then : If U2 =< 700 Then : Knopka2 = "E" : Goto Knop2 : End If : End If       ' SHIFT ESCAPE
    If U2 > 720 Then : If U2 =< 900 Then : Knopka2 = "p" : Goto Knop2 : End If : End If       '   ENTER
Knop2:
'Stop Watchdog
 End Sub
'-------------------------------------------------------------------------------
'=========    LCD ==============================================
Sub R_lcd(msg As String)


  For Cntr = 1 To Len(msg)
    Rus = Mid(msg , Cntr , 1)
    I_lcd = Asc(rus)
    If I_lcd > 191 Then
      I_lcd = I_lcd - 192
      I_lcd = Lookup(i_lcd , Tbl_lcd)
      Rus = Chr(i_lcd)
    End If
    Lcd Rus
  Next Cntr
End Sub
Tbl_lcd:
Data &H41 , &HA0 , &H42 , &HA1 , &HE0 , &H45 , &HA3 , &HA4
Data &HA5 , &HA6 , &H4B , &HA7 , &H4D , &H48 , &H4F , &HA8
Data &H50 , &H43 , &H54 , &HA9 , &HAA , &H58 , &HE1 , &HAB
Data &HAC , &HE2 , &HAD , &HAE , &H62 , &HAF , &HB0 , &HB1
Data &H61 , &HB2 , &HB3 , &HB4 , &HE3 , &H65 , &HB6 , &HB7
Data &HB8 , &HB9 , &HBA , &HBB , &HBC , &HBD , &H6F , &HBE
Data &H70 , &H63 , &HBF , &H79 , &HE4 , &H78 , &HE5 , &HC0
Data &HC1 , &HE6 , &HC2 , &HC3 , &HC4 , &HC5 , &HC6 , &HC7
'*******************************************************************************


  Tim1_int:
Incr Djamb
Return